MUSIC_CMD_STOP = $00
MUSIC_CMD_CH1 = $70
MUSIC_CMD_CH2 = $71
MUSIC_CMD_CH3 = $72
MUSIC_CMD_CH4 = $73
MUSIC_CMD_JUMP = $74    ; index
MUSIC_CMD_FDIFF = $75    ; freq diff/frame
MUSIC_CMD_NOTEOFF = $7f

music_delay = Music_zp_base + 0

music_init:
    jmp music_init_do
music_play:
music_play_ch = * + 1
    ldx #$ff
    bmi music_exit

    dec music_delay
    bpl music_play_set

music_play_i = * + 1
    ldy #$00

music_play_loop:
    lda music_data,y
    beq music_exit
    bmi music_play_got_note
    cmp #MUSIC_CMD_CH1
    bcc music_play_got_delay
    cmp #MUSIC_CMD_NOTEOFF
    beq music_play_got_noteoff
    cmp #MUSIC_CMD_JUMP
    beq music_play_got_jump
    bcc music_play_got_ch

music_play_got_fdiff:
    iny
    lda music_data,y
    sta music_play_fdiff
    iny
    bne music_play_loop ; bra

music_play_got_jump:
    iny
    lda music_data,y
    tay
    jmp music_play_loop

music_play_got_ch:
    and #3
    tax
    stx music_play_ch
    iny
    jmp music_play_loop

music_play_got_noteoff:
    lda #0
music_play_got_note:
    sta $900a,x
    iny
    bne music_play_loop ; bra

music_play_got_delay:
    sta music_delay
    iny
    sty music_play_i

music_play_set:
music_play_fdiff = * + 1
    lda #$00
    clc
    adc $900a,x
    sta $900a,x
music_exit:
    rts

music_init_do:
    ; disable music_play
    ldx #$ff
    stx music_play_ch
    ; init state
    tax
    lda music_tune,x
    sta music_play_i
    lda #0
    sta $900a
    sta $900b
    sta $900c
    sta $900d
    sta music_play_fdiff
    lda #1
    sta music_delay
    ; enable music_play
    lda #0
    sta music_play_ch
music_init_do_smc_x = * + 1
    ldx #0
-   rts

music_data:
!by 0
music_data_fx0:
!by 0
music_data_fx1:
!by MUSIC_CMD_CH3, $dc, MUSIC_CMD_FDIFF, -1, 25, MUSIC_CMD_FDIFF, -2, 50, MUSIC_CMD_FDIFF, 0, MUSIC_CMD_NOTEOFF, 0
music_data_fx2:
!by MUSIC_CMD_CH4, $f0, 1, $e0, 1, $d0, 1, MUSIC_CMD_NOTEOFF, 0
music_data_fx3:
!by MUSIC_CMD_CH4, $92, 1, $a2, 1, $9f, 1, MUSIC_CMD_NOTEOFF, 0
music_data_fx4:
!by MUSIC_CMD_CH4, $ff, 1, MUSIC_CMD_NOTEOFF, MUSIC_CMD_CH3, $e0, 1, MUSIC_CMD_NOTEOFF, 0
music_data_fx5:
!by MUSIC_CMD_CH4, $ff, 1, MUSIC_CMD_NOTEOFF, MUSIC_CMD_CH3, $a0, 1, MUSIC_CMD_NOTEOFF, 0
music_data_fx6:
!by MUSIC_CMD_CH3, $d1, 5, MUSIC_CMD_NOTEOFF, 5, MUSIC_CMD_JUMP, music_data_fx6 - music_data + 1

!if * - music_data > $100 {
!error "music data too long"
!error * - music_data - $100
}

music_tune:
!by music_data_fx0 - music_data
!by music_data_fx1 - music_data
!by music_data_fx2 - music_data
!by music_data_fx3 - music_data
!by music_data_fx4 - music_data
!by music_data_fx5 - music_data
!by music_data_fx6 - music_data
